"""TinyTinyEdit -- A minimal Document-based Cocoa application."""


from PyObjCTools import NibClassBuilder, AppHelper


## the mac build process is nutty -- some modules don't get picked up
## so we load them here to make sure.
import SimpleHTTPServer, select, new, weakref, cPickle, urllib2, webbrowser
import fpformat, pickle, db_sqlite, sumer, encodings.idna, encodings.ascii
import encodings, sgmllib, meta_google, meta_teoma

#f = open("/Users/los/code/pws/d.log", "w")
#sys.stdout = f
#sys.stderr = f

NibClassBuilder.extractClasses("TinyTinyDocument")


# class defined in TinyTinyDocument.nib
class TinyTinyDocument(NibClassBuilder.AutoBaseClass):
    # the actual base class is NSDocument
    # The following outlets are added to the class:
    # textView

    path = None

    def windowNibName(self):
        return "TinyTinyDocument"

    def readFromFile_ofType_(self, path, tp):
        if self.textView is None:
            # we're not yet fully loaded
            self.path = path
        else:
            # "revert"
            self.readFromUTF8(path)
        return True

    def writeToFile_ofType_(self, path, tp):
        f = file(path, "w")
        text = self.textView.string()
        f.write(text.encode("utf8"))
        f.close()
        return True

    def windowControllerDidLoadNib_(self, controller):
        if self.path:
            self.readFromUTF8(self.path)

    def readFromUTF8(self, path):
        f = file(path)
        text = unicode(f.read(), "utf8")
        f.close()
        self.textView.setString_(text)

    ## start off all the little daemons
    import dowser, crawler, thread, time

    thread.start_new_thread(dowser.run_chdir, ())
    
    time.sleep(0.350)
    thread.start_new_thread(crawler.run, ())
 

if __name__ == "__main__":
    AppHelper.runEventLoop()