#! /usr/bin/env python
"""
interface to browse and search the local cache. 

"""

import os
import string
import urllib
import db
import sys
import sha
import search
import msg
import util



## this is similar to search.py, except different :)
def formatResults(results, qs):
	if not results or results == []: return ""
	
	retval = []
	cnt = 0
	for row in results:
		if row:
			## trim URLs for prettyness
			if len(row['url']) > 70:
				row['pretty'] = row['url'][7:67] + "..."
			else:
				row['pretty'] = row['url'][7:len(row['url'])]
				
			##trim title
			if len(row['title']) > 70:
				row['title'] = row['title'][0:67] + "..."

			row['urlhash'] = sha.new(row['url']).hexdigest()
		
			## is your head hurting yet?
			retval.append("""
				<li id=item%(cnt)d><a href="/cache?urlHash=%(u)s">%(t)s</a>
			""" % {
				'u': row['urlhash'], 't': row['title'], 'cnt':cnt})
			
			if row.has_key('desc'):
				retval.append("<div class=desc>%s</div>" % row['desc'])
			
			retval.append("<div class=url>%s</div>" % row['pretty'])
			
			
			retval.append("""<div><small><small>
					%s - % s  &nbsp;
					[<a href=/browse_history?urlHash=%s>%s</a>] &nbsp;
					[<a href=%s>%s</a>]   &nbsp;
					[<a href="/delete?urlhash=%s&qs=%s">%s</a>]
				""" % (
					util.shortdate(row['date']),
					util.shortbytes(row['size']),
					sha.new(row['url']).hexdigest(),
					msg.msg['HISTORY'],
					row['url'], 
					msg.msg['DIRECT_LINK'],
					row['urlhash'],
					urllib.quote_plus(urllib.quote_plus(qs)),
					msg.msg['DELETE']
					)
			)
			
			retval.append("</small></small></div></li>")
			cnt = cnt +1
	
	return ''.join(retval)


##########################################################################

def run(env, args, out):
	
	format = util.header + """
		
		<div class=res >
		
					
		&nbsp;&nbsp;&nbsp;&nbsp;<span class="frm">&nbsp; %(LOCAL_CACHE)s:
		<b>%(title)s</b> &nbsp;</span>

			<div class=sidebar>
				
					%(clusters)s
					
					<div class=cluster><small> 
					<b>%(RECENT_SEARCHES)s:</b> <br />
					%(history)s
					</small></div>
				
			</div>
			
			<div >
			<ul id="reslist">%(body)s</ul>
			</div>
		</div>
	""" + util.footer


	by = urllib.unquote_plus(args['by'])
	
	q = ''
	
	if args.has_key('q'):
		q = urllib.unquote_plus(args['q'])
	


	db.init()
	
	related = ""
	clusters = ""
	
	
	##no specific query, list all.
	##todo: need better listing/column logik?
	if (not q):
		if (by == 'kw'):
			results = db.getUrlKeywords()
			title = msg.msg['LOCAL_CACHE_BY_KEYWORD']
		else: ## if by == 'date':
			results = db.searchLibraryByLatest()
			title = msg.msg['LATEST_CACHE']
				
	else:
		## listing pages by kwd(s) linked to them
		if (by == 'kw'):
			results = db.searchLibrary(q)
			
			##goto summart on single rsult
			if len(results) == 1:
				import browse_history
				args['urlHash'] = sha.new(results[0]['url']).hexdigest()
				browse_history.run(env, args, out)
				return
							
			title = q
			
			related = search.formatRelated(db.relatedKw(q))
			clusters = search.formatClusters(search.cluster5(results), q)
		else:
			pass #todo: wtf do we do here?


	
	
	out.write("Content-type: text/html\n\n")
	
	##stupid database tricks: last X searches..
	herstory = db.getSearchHistory(25)
	history = '\n'.join([
		"""&#0149;&nbsp;<a href="/search?q=%s">%s</a><br/>
		""" % (util.htmlencode(h[0]), util.htmlencode(h[0])) for h in herstory
	])
	
	
	## build the main results list
	body = ""
	
	##todo: need better method for >500 items?
	if (not q):
				
		##nice alpha list
		curr_letter = ""
		if (by == 'kw') and results:
			for d in results:
				if d[0] != "" and d[0][0] != curr_letter and d[0][0] != "":
					if curr_letter != "":
						body += "</small></div>"
					body += """
						<div class=let><div><big>%s</big></div><small>
					""" % d[0][0].upper()
					curr_letter = d[0][0]
			
				body += """
					<a href="browse?by=%s&q=%s">%s</a>&nbsp;(%d) 


				""" % (by, d[0], d[0], d[1])
		else: 
			##last 50
			body = formatResults(results, args['--qs'])
			
	else:
		body = formatResults(results, args['--qs'])
	
	##db.dump()

	info = {}
	info.update(msg.msg)
	info.update({'body': body, 'title': util.htmlencode(title), 'related': related, 'clusters': clusters, 'history': history})
	
	out.write(format % info)
	
