#! /usr/bin/env python
"""
'prefs' page -- change the port number, allow/disallow remote access,
change language, etc.

"""

import os
import string
import urllib
import db
import sys
import search
import msg
import util


##########################################################################
## adds a "_checked" entry in the table to mark True flags as checked
## in the HTML
def checker(key, prefs):	
	if prefs[key]:
		prefs[key+'_checked'] = "checked=checked"
	else:
		prefs[key+'_checked'] = ""
		
		
def run(env, args, out):

	format = util.header + """
		
		<div class=res>

			<form action="/prefs_save">
			
			<div class="inset">
			<p>
			%(LANGUAGE)s
			%(lang_select)s 
			</p>
			
			
			%(MAX_PAGE)s <input type="text" size="5" maxlength="5" 
			name="max_page" value="%(max_page)d" />
			<small>1-100</small>
			
			<p>
			<small>%(SEARCH_SITES_BLURB)s</small><br/>
			%(sites)s
			</p>
			<p>
			<input type="checkbox" name="check_upgrades" value="1" 
			%(check_upgrades_checked)s /> %(CHECK_UPGRADE)s 
			</p>
			<p>
			<input type="checkbox" name="launch_browser" value="1" 
			%(launch_browser_checked)s /> %(LAUNCH_BROWSER)s 
			</p>
			
			<input type="submit" value="%(SAVE)s" />
			</div>
			
			
			<div class="inset">
			<p>
			<input type="checkbox" name="use_proxy" value="1" 
			%(use_proxy_checked)s /> %(USE_PROXY)s 
			</p>
			<p>
			%(PROXY)s <input type="text" size="20" maxlength="64" 
			name="proxy" value="%(proxy)s" />
			</p>
			<p>
			%(PROXY_PORT)s <input type="text" size="5" maxlength="5" 
			name="proxy_port" value="%(proxy_port)d" />
			<small>1 - 65500</small>
			</p>
			
			<p>
			<input type="submit" value="%(SAVE)s" />
			</p>
			
			</div>
			
			<div class="inset">
			<p>
			%(PORT)s <input type="text" size="5" maxlength="5" 
			name="port" value="%(port)d" />
			<small>1025 - 65500</small>
			</p>
			
			<p>
			<input type="checkbox" name="allow_remote_clients" value="1" 
			%(allow_remote_clients_checked)s /> %(ALLOW_REMOTE_CLIENTS)s
			<br/><small>%(REMOTE_CLIENTS_WARNING)s </small>
			</p>
			
			<p>
			<input type="submit" value="%(SAVE)s" />
			</p>
			
			</div>
			
			</form>
			
		</div>
	""" + util.footer

	prefs = {}
	prefs.update(util.prefs)
	
	
	## Baggin the flagon with the dragon
	checker('use_proxy', prefs)
	checker('check_upgrades', prefs)
	checker('launch_browser', prefs)
	checker('allow_remote_clients', prefs)	
	
	
	out.write("Content-type: text/html\n\n")
	
	##make input list of "search sites"
	sites = ["""<textarea name="site_searches" rows="8" cols="20">"""]
	for s in prefs['site_searches']:
		sites.append(s)
	sites.append("""</textarea>""")
	sites = '\n'.join(sites)
	
	##select box of available languages
	lang_select = util.mkselect(msg.langs, 'lang', prefs['lang'])

	info = {'lang_select': lang_select, 'sites':sites}
	info.update(msg.msg)
	info.update(prefs)
	out.write(format % info)
	
	out.flush()
	out.close()
