#! /usr/bin/env python
import os
import string
import urllib
import urlparse
import db
import sys
import re
import sha

import msg
import util

	

"""
I am absolutely sure I have not comprehended the scoping and list issues
in python.

todo: "-blog" flag ?.
"""

num_library = 6




def formatResults(results, q):
	retval = []
	
	format = """
	<li id=item%(cnt)d>
		<a href="click?url=%(url)s&q=%(q)s&d=%(desc)s&t=%(title)s">%(titlep)s</a>
		%(descp)s
		<div class=url>%(pretty)s</div>
		<div><small><small> %(cacheline)s %(cache)s %(gcache)s</small></small>
		</div></li>
	"""
	
	cnt = 0
	for row in results:
		if (row != None):
			info = {'cnt': cnt, 
				'url': urllib.quote_plus(urllib.quote_plus(row['url'])),
				'title': urllib.quote(row['title']), 
				'q': urllib.quote(q),
				'titlep': row['title'],
				'desc': urllib.quote(row['desc']),
				'descp':'',
				'cacheline':'',
				'cache':'',
				'gcache':''}
			
			## trim URLs for prettyness
			if len(row['url']) > 70:
				info['pretty'] = row['url'][7:67] + "..."
			else:
				info['pretty'] = row['url'][7:len(row['url'])]
			
			if row.has_key('desc'):
				info['descp'] = "<div class=desc>%s</div>" % row['desc']
						
			if (row.has_key('gcache') and row['gcache']) or row['cached']:
				info['cacheline'] = "%s :" % msg.msg['CACHED']
			
			if row['cached']:
				info['cache'] = """
					[<a href=cache?urlHash=%(u)s>%(LOCAL)s</a>]
					[<a href=browse_history?urlHash=%(u)s>%(HISTORY)s</a>]
				""" % {'u': sha.new(row['url']).hexdigest(),
					'LOCAL': msg.msg['LOCAL'], 'HISTORY': msg.msg['HISTORY']}
				
			if row.has_key('gcache') and row['gcache']:
				info['gcache'] = """
					[<a href=%s>%s</a>]
				""" % (row['gcache'], msg.msg['GOOGLE'])
				
			
			retval.append(format % info)
			cnt = cnt +1
	
	return '\n'.join(retval)
	
	
## todo: obsoleted by the inline 'cached' links?
def formatLibrary(results, q):
	if results == None or results == []:
		return ""

	retval = "<div class=library><small> <b>%s:</b> <br />" % msg.msg['LOCAL_CACHE']
	for row in results:
		pretty = urlparse.urlparse(row['url'])
		pretty = pretty[1]
		
		if(len(row['title']) > 30):
			row['title'] = row['title'][0:27] + "..."
	
		retval = retval +  "<a href=cache?urlHash=" + row['hash'] + ">"
		retval = retval +  row['title'] + "</a><small>"
		#retval = retval +  "<div class=desc>" + row['desc'] + "</div>"
		retval = retval +  "<div class=url>" + pretty
		retval = retval +  "</div></small>"

	return retval + """
		<b>&#0187;<a href="/browse?by=kw&q=%s">%s</a></b>
		</small></div>
	""" % (util.htmlencode(q), msg.msg['MORE...'])
		
		
## todo: useful?
def formatRelated(results):
	if results == None or results == []:
		return ""
		
	retval = "<div class=related><small> <b>Related Keywords:</b> <br /><small>"
	for row in results:
		retval = retval + "<a href=\"javascript:addkw('" + row[0] + "');\">"+row[0]+"</a> "

	return retval + "</small></small></div>"



def formatClusters(clusters, q):
	if clusters == None: return ""
	
	retval = """
		<div class=cluster><small> <b>%(SUBTOPICS)s:</b> <br />
		&nbsp;&nbsp;&nbsp;<a href="javascript:showAll();">(%(ALL)s)</a> <br />
	""" % msg.msg
	
	for c in clusters[0:10]:
		cname = c[0]
		if cname in q: continue
		retval = retval +   """
			&nbsp;&nbsp;&nbsp;<a href=\"javascript:cluster(%s);\">%s (%d)</a> <br /> 
		""" % (str(c[1].keys()), cname, len(c[1])) 
	return retval + "</small></div>"






## this isn't really 'clustering', but a fancy tdf*idf
##todo: stemming.... multilanguage?
r_word = re.compile(r"[\W]+")
def cluster5(data):
	global r_word

	doctree = {}
	wordtree = {}
	heir = {}
	wordlist = []

	##produces two indexes: word-->documents and document-->words
	
	##todo: redo with list comprehensions
	
	for i in range(len(data)):
		d = data[i]
		if d != None: 
			txt = "%s %s %s" % (d['title'],d['desc'],d['url'])
			words = r_word.split(string.lower(txt))
			words = filter(msg.stopword, words)
			for w in words:
				if (doctree.has_key(i)):
					doctree[i][w] = 0
				else:
					doctree[i] = {w: 0}
					
				if wordtree.has_key(w):
					wordtree[w][i] = 0
				else:
					wordtree[w] = {i: 0}
					
	## now we have these indices, webuild another 'tree' of words to words.
	## sort the word list by number of documents, and examine each one to
	## see if it is a subset.
	items = [(v, k) for k, v in wordtree.items()]
	items.sort()
	items.reverse()             # so largest is first
	items = [(k, v) for v, k in items]
	
	
	##now 'cluster' words that appear in the same pages
	##todo: need fuziness -+1 or 2 items
	##todo: this can proly be done MUCH better
	for i in range(len(items)):
		for j in range(i+1, len(items)-i-1):
			#print items[i]
			#print items[j]
			#print "<hr/>"
			if (items[j]) and (items[i]):
				if (items[i][1] == items[j][1]): ##exact match
					items[i] = ("%s %s" % (items[i][0], items[j][0]), items[i][1])
					items[j] = None
	
	##remove duped items
	items = filter((lambda x: x != None), items)
	
	##lower bound for 'signifigant' clusters is 3
	items = filter((lambda x: len(x[1]) > 3), items)
	
	items.reverse()
	
	"""##now, get tricky and figure out hierarchies, from the bottom up.	
	for i in range(len(items)):
		for j in range(i+1, len(items)-i-1):
	
			if (isSubset(items[i][1], items[j][1])):
				if heir.has_key(items[j][0]):
					heir[items[j][0]].append(items[i][0])
				else:
					heir[items[j][0]] = [items[i][0]]
				#break
						
	
	hitems = [(v, k) for k, v in heir.items()]
	hitems.sort()
	hitems.reverse()             # so largest is first
	hitems = [(k, v) for v, k in hitems]"""
	
	##not ready for primetime
	#for h in hitems:
	#	print h
	#	print "<hr/>"
	
	#for w in items:
	#	print w
	#	print "<hr />"
	
	items.reverse()
	
	if items == []: return None
	
	return items

##########################################################################

##todo: thread-safe?


def run(env, args, out):
	import meta, thread, time

	results = util.ResultList()

	global num_library
	
	out.write("Content-type: text/html; charset=utf-8\n")
	out.write("Connection: close\n\n")


	#####################
	###TODODODODOD!!
	####### figgoure out list vs string
	###update chekcked vs unchecked filters
	### "display" (original) query versus the "processed" query.
	## look up any search filters
	filters=""
	if args.has_key('filters'):
		filters = []
		if isinstance(args['filters'], list):
			for f in args['filters']:
				if util.prefs['filters'].has_key(f):
					filters.append( util.prefs['filters'][f]['flags'] )
		else:
			if util.prefs['filters'].has_key(args['filters']):
				filters.append( util.prefs['filters'][args['filters']]['flags'] )
			
		filters = " ".join(filters)

	##user query (duh)
	display_q = args['q']
	q = args['q'] + " " + filters
	
	## the 'source'
	if args.has_key('s'):
		s = args['s']
		#set 'default' engine
		util.prefs['default_engine'] = s
		print s
		util.saveprefs()
		
		## special 'in site' search via google
		if s[:5] == "site:":
			q = s + " " + q
			s = "web:google"
	else:
		s = "web"
	
	library = None
	related = None
	

	
	##special case: only searching local lib? redirect to 'browse' page
	if s == "local":
		out.write( """
			<meta http-equiv="REFRESH" content="0; url=/browse?by=kw&q=%s" />
		""" % util.htmlencode(display_q))
		out.flush()
		out.close()
		return


	## create the page template
	page_format = util.header + """

		<div class=res>
			
			<!-- column; floats right -->
			<div class=sidebar>
				
					%(clusters)s
					%(related)s
					%(library)s
			</div>	
			<!--main results-->
			<ol id="reslist">
				%(results_formatted)s
			<ol>
		</div><!--res-->
	""" + util.footer
	
	
	db.init()
	
	related = db.relatedKw(display_q)
	
	library = db.searchLibrary(display_q)
	
	
	## log the query and get out of db.
	db.recordSearch(display_q)
	##db.dump()
	
	related = formatRelated(related)

	lib_formatted = ""
	
	if library:
		if len(library) > num_library:
			lib_formatted = formatLibrary(library[0:num_library], display_q)
		else:
			lib_formatted = formatLibrary(library, display_q)
		
	## python is pass-by reference??? bloody hell
	page_vars = {}
	page_vars.update(msg.msg)  ## add i18n words
	page_vars.update({'q': util.htmlencode(display_q), 'library': lib_formatted, 
		'title':'Dowser: ' + util.htmlencode(display_q), 'related':related})
	
	
	
	if s[:3] == "web":

		if s == "web":
			meta.search(q, results)
		elif s == "web:google":
			meta.google(q, results)
		elif s == "web:teoma":
			meta.teoma(q, results)
		
		## simple 'clustering' of results
		clusters = formatClusters(cluster5(results), q)

		
		##tag items that are in the library as cached.
		##todo: remove 'matched' lib items from the sidebar list?
		if library:
			##create a lookup table for library items
			lib_lookup = {}
			for l in library:
				lib_lookup[l['url']] = True
				
			for r in results:
				if r and r != []:
					if lib_lookup.has_key(r['url']):
						r['cached'] = True
				
		
		fresults = formatResults( results, display_q )
		
		page_vars.update({'clusters': clusters, 'results_formatted': fresults})
		
	
	out.write(page_format % page_vars)
		
	results=util.ResultList()
	q = ''
	display_q = ''
	
	out.flush()
	out.close()
	
	## ... and may flights of packets speed you to your RST.
	## exuent, stage left




