"""
"countdown" and "timer" locks modeled after Doug Lea's util.concurrent 
java library.
"""
import time
		

## This lock allows for multiple threads to wail on the same lock.
## once it has been "released" 5 or 3 or however many times given
## in the __init__, it will unlock.
class countdown:
	def __init__(self, count):
		self.count = int(count)
		self.lock=True
				
	def release(self):
		self.count -= 1
		print "count is %d" % self.count
		if self.count <= 0:
			self.lock=False
			
	def locked(self):
		return self.lock

## standard timeout lock. if not released after x seconds (you can use a
## float for fractions) it releases automagically.
class timer:
	def __init__(self, timeout):
		self.start = time.time()
		self.timeout = timeout
		self.lock=True
	
	def locked(self):
		if self.lock:
			return not ((time.time() - self.start) >= self.timeout)
		else:
			return False
		
## Lea uses really trick OO stuff to allow "nesting" whatever combo of
## locks you want, but I'm lazy and prefer a simpler interface.
## this bugger is a cross between a countdown and a timer. It takes
## both a release count and a timeout, and unlocks when EITHER of
## them are satisfied.
class count_timer:
	def __init__(self, count, timeout):
		self.c = countdown(count)
		self.t = timer(timeout)
		
	def release(self):
		self.c.release()
		
	def locked(self):
		##yeah, yeah, i know. but it's late and it works.
		return not ((not self.c.locked()) or (not self.t.locked()))