#! /usr/bin/env python

"""
This is the metasearch library. at some point it will be subclassed and 
threaded to allow us to get stuff from teoma, nutch, etc as well as google.

note: urllib2 is loading veeery slowly on my system. 500 msecs just to import it!
switched to httplib. what's annoying is that urllib is fastest AND can use proxies,
but you can't set the needed headers to fool google. *sigh*

"""
import urlparse
import urllib
import string
import re
import sys
import util
import os
from meta import getPage

debug = 0

"""
Basic process: strip off header and footer (dataBegin, etc), get rid of useless
tags and such (removeRE), split what's left into "rows" (splitRE) and match
each row against the "link pattern" to extract the url, title, description, etc.

todo: mozilla used to have a nifty metasearch that relied only on a "config"
file. i wonder if they had a better way than this hack'n'slash?
"""
removeRE = r"</?b[^>]*>|</?font[^>]*>|</?i>|</?span[^>]*>|</?table[^>]*>"
dataBegin = r"<!--a--><div>"
dataEnd = r"<!--z-->"
splitRE = r"<!--m-->"
match = r"^<a href="


headers = {
	"User-Agent":"Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.6) Gecko/20040206 Firefox/0.8",
	"Accept-Charset":"utf-8,ISO-8859-1;q=0.7,*;q=0.7",
	"Accept-Language":"en-us,en;q=0.5",
	"Accept":"text/html,*/*",
	"Accept":"gzip"
}




def strip(text): 
	text = string.replace(text, "\n", " ")
	text = re.sub(removeRE, " ", text)
	
	sidx = string.find(text, dataBegin)
	eidx = string.find(text, dataEnd)
	
	if (sidx > -1 and eidx > -1): 
		text = text[sidx:eidx]
	
	
	return text


	
def split(text): 
	return re.split(splitRE, text)
 

r_url_title = re.compile(r"<a href=(http://[^>]+)>([^<]+)</a>")
r_gcache = re.compile(r"(/search\?q=cache:[^>]+)")
def extractResult(text): 
	global r_url_title
	if debug:
		print "Row Text: -------------------------------"
		print text
		print

	

	##extract the title and URL
	p = r_url_title.search(text)
	if (p != None):
		url = p.group(1)
		result = {'url': string.strip(url), 'title': string.strip(p.group(2))}
	else:
		return None
	
	
	##grab the google cache link
	p = r_gcache.search(text)
	if p != None:
		result['gcache'] = 'http://www.google.com' + p.group(1)
	else:
		result['gcache'] = None
	
	##todo: need to strip the Google 'extras' like PDF format text that
	##precedes the desc.
	##extract the description
	desc = stripLinks(text)
	desc = re.sub(r"\s-|-\s|\]|\[", '', desc)
	desc = re.sub(r"<[^>]+>", '', desc) ##html tags
	desc = string.strip(desc)
	
	##remove url from description
	## todo: goog sometimes inserts spaces in the url... hmm....
	i = string.find(desc, url[7:11]) #http://[www.]yadda.com
	if (i > -1):
		desc = desc[0:i]
		
	result['desc'] = desc
	result['cached'] = False ## cause this is a 'live' result


	return result ## as a dictionary object
    
r_links = re.compile(r"<a[^>]+>[^<]*</a>")
def stripLinks(text): 
	global r_links
	return r_links.sub('', text)




def search(query, results=util.ResultList(), lock=None):
	global headers
	page = "http://www.google.com/search?sourceid=mozilla-search&start=0&num=%d&ie=utf-8&oe=utf-8&q=%s" % (util.prefs['max_page'], urllib.quote_plus(query))
	
	#page = "http://localhost/test.html"
	#page = "http://localhost:10000"

	try: 
		print page
		page = getPage(page, headers)
		 
		##print page
		
		page = strip(page)
	
		cnt = 0
		for row in split(page): 
			r = extractResult(row)
			if(r != {}):
				results.append(r)
	
		
	except:
		print "error in meta.search()"
		if lock: lock.release()
		raise

	if lock: 
		lock.release()
		print "google releasing"
	return results



